image: node:10.15-slim

stages:
  - test
  - publish

test:
  stage: test
  before_script:
    - npm install
    - npm run build
  script:
    - npm test

publish:
  stage: publish
  only: [tags]
  before_script:
    - echo "//registry.npmjs.org/:_authToken=${NPM_TOKEN}" > ~/.npmrc
    - npm install -g replace-in-file
    - replace-in-file "0.0.0-version-placeholder" "${CI_COMMIT_TAG}" package.json
    - npm install
    - npm run build
  script:
    - npm publish --access=public
